Package org.opensaml.core.xml

# Interface XMLObjectBuilder<XMLObjectType extends XMLObject>

Type Parameters:
  `XMLObjectType` - the XMLObject type that this builder produces

All Known Subinterfaces:
  `SAMLObjectBuilder<SAMLObjectType>`, `SOAPObjectBuilder<SOAPObjectType>`, `WSAddressingObjectBuilder<WSAddressingObjectType>`, `WSFedObjectBuilder<WSFedObjectType>`, `WSPolicyObjectBuilder<WSPolicyObjectType>`, `WSSecurityObjectBuilder<WSSecurityObjectType>`, `WSTrustObjectBuilder<WSTrustObjectType>`, `XACMLObjectBuilder<XACMLObjectType>`, `XMLEncryptionBuilder<XMLEncryptionType>`, `XMLSignatureBuilder<XMLSignatureType>`

All Known Implementing Classes:
  `AbstractSAMLObjectBuilder`, `AbstractWSAddressingObjectBuilder`, `AbstractWSPolicyObjectBuilder`, `AbstractWSSecurityObjectBuilder`, `AbstractWSTrustObjectBuilder`, `AbstractXACMLObjectBuilder`, `AbstractXMLObjectBuilder`, `ActionBuilder`, `ActionBuilder`, `ActionBuilder`, `ActionMatchTypeImplBuilder`, `ActionNamespaceBuilder`, `ActionsTypeImplBuilder`, `ActionTypeImplBuilder`, `ActionTypeImplBuilder`, `AdditionalMetadataLocationBuilder`, `AddressBuilder`, `AddressBuilder`, `AdviceBuilder`, `AdviceBuilder`, `AffiliateMemberBuilder`, `AffiliationDescriptorBuilder`, `AgreementMethodBuilder`, `AllBuilder`, `AllowPostdatingBuilder`, `AppliesToBuilder`, `AppliesToBuilder`, `ApplyTypeImplBuilder`, `ArtifactBuilder`, `ArtifactResolutionServiceBuilder`, `ArtifactResolveBuilder`, `ArtifactResponseBuilder`, `AssertionArtifactBuilder`, `AssertionBuilder`, `AssertionBuilder`, `AssertionConsumerServiceBuilder`, `AssertionIDRefBuilder`, `AssertionIDReferenceBuilder`, `AssertionIDRequestBuilder`, `AssertionIDRequestServiceBuilder`, `AssertionURIRefBuilder`, `AsynchronousBuilder`, `AttributeAssignmentTypeImplBuilder`, `AttributeAuthorityDescriptorBuilder`, `AttributeBuilder`, `AttributeBuilder`, `AttributeConsumingServiceBuilder`, `AttributeDesignatorBuilder`, `AttributeDesignatorTypeImplBuilder`, `AttributeProfileBuilder`, `AttributeQueryBuilder`, `AttributeQueryBuilder`, `AttributeQueryDescriptorTypeBuilder`, `AttributeSelectorTypeImplBuilder`, `AttributeServiceBuilder`, `AttributeStatementBuilder`, `AttributeStatementBuilder`, `AttributeTypeImplBuilder`, `AttributeValueBuilder`, `AttributeValueBuilder`, `AttributeValueTypeImplBuilder`, `AttributeValueTypeImplBuilder`, `AudienceBuilder`, `AudienceBuilder`, `AudienceRestrictionBuilder`, `AudienceRestrictionConditionBuilder`, `AuthenticatingAuthorityBuilder`, `AuthenticationQueryBuilder`, `AuthenticationStatementBuilder`, `AuthenticationTypeBuilder`, `AuthenticatorBuilder`, `AuthnAuthorityDescriptorBuilder`, `AuthnContextBuilder`, `AuthnContextClassRefBuilder`, `AuthnContextDeclBuilder`, `AuthnContextDeclRefBuilder`, `AuthnQueryBuilder`, `AuthnQueryDescriptorTypeBuilder`, `AuthnQueryServiceBuilder`, `AuthnRequestBuilder`, `AuthnStatementBuilder`, `AuthorityBindingBuilder`, `AuthorizationDecisionQueryBuilder`, `AuthorizationDecisionStatementBuilder`, `AuthzDecisionQueryBuilder`, `AuthzDecisionQueryDescriptorTypeBuilder`, `AuthzDecisionStatementBuilder`, `AuthzServiceBuilder`, `BinaryExchangeBuilder`, `BinarySecretBuilder`, `BinarySecurityTokenBuilder`, `BodyBuilder`, `CancelTargetBuilder`, `CanonicalizationAlgorithmBuilder`, `CarriedKeyNameBuilder`, `ChallengeBuilder`, `ChannelBindingsBuilder`, `CipherDataBuilder`, `CipherReferenceBuilder`, `CipherValueBuilder`, `ClaimsBuilder`, `CodeBuilder`, `CombinedHashBuilder`, `CombinerParametersTypeImplBuilder`, `CombinerParameterTypeImplBuilder`, `CompanyBuilder`, `ComputedKeyAlgorithmBuilder`, `ComputedKeyBuilder`, `ConcatKDFParamsBuilder`, `ConditionsBuilder`, `ConditionsBuilder`, `ConditionTypeImplBuilder`, `ConfirmationMethodBuilder`, `ContactPersonBuilder`, `CreatedBuilder`, `CryptoBinaryBuilder`, `DataReferenceBuilder`, `DecisionTypeImplBuilder`, `DefaultsTypeImplBuilder`, `DelegatableBuilder`, `DelegateBuilder`, `DelegateToBuilder`, `DelegationRestrictionTypeBuilder`, `DEREncodedKeyValueBuilder`, `DerivedKeyBuilder`, `DerivedKeyNameBuilder`, `DescriptionBuilder`, `DescriptionTypeImplBuilder`, `DetailBuilder`, `DHKeyValueBuilder`, `DigestMethodBuilder`, `DigestMethodBuilder`, `DiscoHintsBuilder`, `DiscoveryResponseBuilder`, `DisplayNameBuilder`, `DomainHintBuilder`, `DoNotCacheConditionBuilder`, `DSAKeyValueBuilder`, `ECKeyValueBuilder`, `EmailAddressBuilder`, `EmbeddedBuilder`, `EncryptedAssertionBuilder`, `EncryptedAttributeBuilder`, `EncryptedDataBuilder`, `EncryptedHeaderBuilder`, `EncryptedIDBuilder`, `EncryptedKeyBuilder`, `EncryptionAlgorithmBuilder`, `EncryptionBuilder`, `EncryptionMethodBuilder`, `EncryptionMethodBuilder`, `EncryptionPropertiesBuilder`, `EncryptionPropertyBuilder`, `EncryptWithBuilder`, `EncTypeBuilder`, `EndpointReferenceBuilder`, `EndPointReferenceBuilder`, `EntitiesDescriptorBuilder`, `EntityAttributesBuilder`, `EntityDescriptorBuilder`, `EntropyBuilder`, `EnvelopeBuilder`, `EnvironmentMatchTypeImplBuilder`, `EnvironmentsTypeImplBuilder`, `EnvironmentTypeImplBuilder`, `EnvironmentTypeImplBuilder`, `EvidenceBuilder`, `EvidenceBuilder`, `ExactlyOneBuilder`, `ExpiresBuilder`, `ExponentBuilder`, `ExtensionsBuilder`, `ExtensionsBuilder`, `FaultActorBuilder`, `FaultBuilder`, `FaultCodeBuilder`, `FaultStringBuilder`, `FaultToBuilder`, `ForwardableBuilder`, `FromBuilder`, `FunctionTypeImplBuilder`, `GBuilder`, `GeneratedKeyBuilder`, `GeneratorBuilder`, `GeolocationHintBuilder`, `GetCompleteBuilder`, `GivenNameBuilder`, `HeaderBuilder`, `IDPEntryBuilder`, `IDPListBuilder`, `IDPSSODescriptorBuilder`, `IdReferenceTypeImplBuilder`, `InformationURLBuilder`, `IPHintBuilder`, `IssuedTokensBuilder`, `IssuerBuilder`, `IssuerBuilder`, `IterationBuilder`, `IterationCountBuilder`, `JBuilder`, `KANonceBuilder`, `KeyDerivationMethodBuilder`, `KeyDescriptorBuilder`, `KeyExchangeTokenBuilder`, `KeyIdentifierBuilder`, `KeyInfoBuilder`, `KeyInfoConfirmationDataTypeBuilder`, `KeyInfoReferenceBuilder`, `KeyLengthBuilder`, `KeyNameBuilder`, `KeyReferenceBuilder`, `KeySizeBuilder`, `KeySizeBuilder`, `KeyTypeBuilder`, `KeyValueBuilder`, `KeywordsBuilder`, `KeyWrapAlgorithmBuilder`, `LifetimeBuilder`, `LogoBuilder`, `LogoutRequestBuilder`, `LogoutResponseBuilder`, `ManageNameIDRequestBuilder`, `ManageNameIDResponseBuilder`, `ManageNameIDServiceBuilder`, `MasterKeyNameBuilder`, `MessageIDBuilder`, `MetadataBuilder`, `MGFBuilder`, `MgmtDataBuilder`, `MissingAttributeDetailTypeImplBuilder`, `ModulusBuilder`, `NamedCurveBuilder`, `NameIDBuilder`, `NameIdentifierBuilder`, `NameIDFormatBuilder`, `NameIDMappingRequestBuilder`, `NameIDMappingResponseBuilder`, `NameIDMappingServiceBuilder`, `NameIDPolicyBuilder`, `NewEncryptedIDBuilder`, `NewIDBuilder`, `NonceBuilder`, `OAEPparamsBuilder`, `ObligationsTypeImplBuilder`, `ObligationTypeImplBuilder`, `OnBehalfOfBuilder`, `OneTimeUseBuilder`, `OrganizationBuilder`, `OrganizationDisplayNameBuilder`, `OrganizationNameBuilder`, `OrganizationURLBuilder`, `OriginatorKeyInfoBuilder`, `OtherSourceBuilder`, `ParticipantBuilder`, `ParticipantsBuilder`, `PasswordBuilder`, `PBKDF2ParamsBuilder`, `PBuilder`, `PBuilder`, `PDPDescriptorBuilder`, `PgenCounterBuilder`, `PgenCounterBuilder`, `PGPDataBuilder`, `PGPKeyIDBuilder`, `PGPKeyPacketBuilder`, `PolicyAttachmentBuilder`, `PolicyBuilder`, `PolicyCombinerParametersTypeImplBuilder`, `PolicyReferenceBuilder`, `PolicySetCombinerParametersTypeImplBuilder`, `PolicySetTypeImplBuilder`, `PolicyTypeImplBuilder`, `PRFBuilder`, `PrimaryBuilder`, `PrivacyStatementURLBuilder`, `ProblemActionBuilder`, `ProblemHeaderQNameBuilder`, `ProblemIRIBuilder`, `ProofEncryptionBuilder`, `ProxyRestrictionBuilder`, `PublicationBuilder`, `PublicationInfoBuilder`, `PublicationPathBuilder`, `PublicBuilder`, `PublicKeyBuilder`, `QBuilder`, `QBuilder`, `ReasonBuilder`, `RecipientKeyInfoBuilder`, `ReferenceBuilder`, `ReferencedPoliciesTypeImplBuilder`, `ReferenceListBuilder`, `ReferenceParametersBuilder`, `RegistrationInfoBuilder`, `RegistrationPolicyBuilder`, `RelatesToBuilder`, `RelayStateBuilder`, `RenewingBuilder`, `RenewTargetBuilder`, `ReplyToBuilder`, `RequestAuthenticatedBuilder`, `RequestBuilder`, `RequestBuilder`, `RequestedAttachedReferenceBuilder`, `RequestedAttributeBuilder`, `RequestedAttributesBuilder`, `RequestedAuthnContextBuilder`, `RequestedProofTokenBuilder`, `RequestedSecurityTokenBuilder`, `RequestedSecurityTokenBuilder`, `RequestedTokenCancelledBuilder`, `RequestedUnattachedReferenceBuilder`, `RequesterIDBuilder`, `RequestInitiatorBuilder`, `RequestKETBuilder`, `RequestSecurityTokenBuilder`, `RequestSecurityTokenCollectionBuilder`, `RequestSecurityTokenResponseBuilder`, `RequestSecurityTokenResponseBuilder`, `RequestSecurityTokenResponseCollectionBuilder`, `RequestTypeBuilder`, `RequestTypeImplBuilder`, `ResourceContentTypeImplBuilder`, `ResourceMatchTypeImplBuilder`, `ResourcesTypeImplBuilder`, `ResourceTypeImplBuilder`, `ResourceTypeImplBuilder`, `RespondToBuilder`, `RespondWithBuilder`, `ResponseBuilder`, `ResponseBuilder`, `ResponseBuilder`, `ResponseTypeImplBuilder`, `ResultTypeImplBuilder`, `RetrievalMethodBuilder`, `RetryAfterBuilder`, `RSAKeyValueBuilder`, `RuleCombinerParametersTypeImplBuilder`, `RuleTypeImplBuilder`, `SaltBuilder`, `SaltBuilder`, `ScopingBuilder`, `SecurityBuilder`, `SecurityTokenReferenceBuilder`, `SeedBuilder`, `SeedBuilder`, `ServiceDescriptionBuilder`, `ServiceNameBuilder`, `SessionIndexBuilder`, `SessionKeyBuilder`, `SignatureAlgorithmBuilder`, `SignatureBuilder`, `SignatureConfirmationBuilder`, `SignChallengeBuilder`, `SignChallengeResponseBuilder`, `SigningMethodBuilder`, `SignWithBuilder`, `SimpleXMLObjectBuilder`, `SingleLogoutServiceBuilder`, `SingleSignOnServiceBuilder`, `SoapActionBuilder`, `SourceIDBuilder`, `SpecifiedBuilder`, `SPKIDataBuilder`, `SPKISexpBuilder`, `SPSSODescriptorBuilder`, `StatusBuilder`, `StatusBuilder`, `StatusBuilder`, `StatusCodeBuilder`, `StatusCodeBuilder`, `StatusCodeTypeImplBuilder`, `StatusDetailBuilder`, `StatusDetailBuilder`, `StatusDetailTypeImplBuilder`, `StatusMessageBuilder`, `StatusMessageBuilder`, `StatusMessageTypeImplBuilder`, `StatusTypeImplBuilder`, `SubjectAttributeDesignatorTypeImplBuilder`, `SubjectBuilder`, `SubjectBuilder`, `SubjectConfirmationBuilder`, `SubjectConfirmationBuilder`, `SubjectConfirmationBuilder`, `SubjectConfirmationDataBuilder`, `SubjectConfirmationDataBuilder`, `SubjectLocalityBuilder`, `SubjectLocalityBuilder`, `SubjectMatchTypeImplBuilder`, `SubjectsTypeImplBuilder`, `SubjectTypeImplBuilder`, `SubjectTypeImplBuilder`, `SurNameBuilder`, `TargetTypeImplBuilder`, `TelephoneNumberBuilder`, `TerminateBuilder`, `TimestampBuilder`, `ToBuilder`, `TokenTypeBuilder`, `TransformationParametersBuilder`, `TransformBuilder`, `TransformsBuilder`, `TransformsBuilder`, `UIInfoBuilder`, `UsagePolicyBuilder`, `UseKeyBuilder`, `UsernameBuilder`, `UsernameTokenBuilder`, `ValidateTargetBuilder`, `VariableDefinitionTypeImplBuilder`, `VariableReferenceTypeImplBuilder`, `X509CertificateBuilder`, `X509CRLBuilder`, `X509DataBuilder`, `X509DigestBuilder`, `X509IssuerNameBuilder`, `X509IssuerSerialBuilder`, `X509SerialNumberBuilder`, `X509SKIBuilder`, `X509SubjectNameBuilder`, `XACMLAuthzDecisionQueryTypeImplBuilder`, `XACMLAuthzDecisionStatementTypeImplBuilder`, `XACMLPolicyQueryTypeImplBuilder`, `XACMLPolicyStatementTypeImplBuilder`, `XPathBuilder`, `XSAnyBuilder`, `XSBase64BinaryBuilder`, `XSBooleanBuilder`, `XSDateTimeBuilder`, `XSIntegerBuilder`, `XSQNameBuilder`, `XSStringBuilder`, `XSURIBuilder`, `YBuilder`

public interface XMLObjectBuilder<XMLObjectType extends XMLObject>
A builder for XMLObjects.

## Method Summary

Modifier and Type
Method
Description
`XMLObjectType`
`buildObject(String namespaceURI, String localName, String namespacePrefix)`
Creates an XMLObject with a given fully qualified name.
`XMLObjectType`
`buildObject(String namespaceURI, String localName, String namespacePrefix, QName schemaType)`
Creates an XMLObject with a given fully qualified name.
`XMLObjectType`
`buildObject(QName objectName)`
Creates an XMLObject with a given fully qualified name.
`XMLObjectType`
`buildObject(QName objectName, QName schemaType)`
Creates an XMLObject with a given fully qualified name and schema type.
`XMLObjectType`
`buildObject(Element element)`
Creates an XMLObject using information from the given DOM element.

## Method Details

### buildObject

@Nonnull XMLObjectType buildObject(@Nonnull QName objectName)
Creates an XMLObject with a given fully qualified name.

Parameters:
  `objectName` - fully qualified name of the object
Returns:
  the constructed XMLObject

### buildObject

@Nonnull XMLObjectType buildObject(@Nonnull QName objectName, @Nullable QName schemaType)
Creates an XMLObject with a given fully qualified name and schema type.

Parameters:
  `objectName` - fully qualified name of the object
  `schemaType` - the schema type of the Element represented by this XMLObject
Returns:
  the constructed XMLObject

### buildObject

@Nonnull XMLObjectType buildObject(@Nullable String namespaceURI, @Nonnull String localName, @Nullable String namespacePrefix)
Creates an XMLObject with a given fully qualified name.

Parameters:
  `namespaceURI` - the URI of the namespace the Element represented by this XMLObject will be in
  `localName` - the local name of the Element represented by this XMLObject
  `namespacePrefix` - the namespace prefix of the Element represented by this XMLObject
Returns:
  the constructed XMLObject

### buildObject

@Nonnull XMLObjectType buildObject(@Nullable String namespaceURI, @Nonnull String localName, @Nullable String namespacePrefix, @Nullable QName schemaType)
Creates an XMLObject with a given fully qualified name.

Parameters:
  `namespaceURI` - the URI of the namespace the Element represented by this XMLObject will be in
  `localName` - the local name of the Element represented by this XMLObject
  `namespacePrefix` - the namespace prefix of the Element represented by this XMLObject
  `schemaType` - the schema type of the Element represented by this XMLObject
Returns:
  the constructed XMLObject

### buildObject

@Nonnull XMLObjectType buildObject(@Nonnull Element element)
Creates an XMLObject using information from the given DOM element. This method must set the QName for the Element QName within the constructed XMLObject. This method is used by `AbstractXMLObjectUnmarshaller`.

Parameters:
  `element` - the DOM Element containing information about the object to be built.
Returns:
  the constructed XMLObject